// This file is generated by WOK (CPPExt).
// Please do not edit this file; modify original file instead.
// The copyright and license terms as defined for the original file apply to 
// this header file considered to be the "object code" form of the original source.

#ifndef _BOP_SolidBuilder_HeaderFile
#define _BOP_SolidBuilder_HeaderFile

#ifndef _Standard_HeaderFile
#include <Standard.hxx>
#endif
#ifndef _Standard_Macro_HeaderFile
#include <Standard_Macro.hxx>
#endif

#ifndef _BOP_LoopSet_HeaderFile
#include <BOP_LoopSet.hxx>
#endif
#ifndef _BOP_BlockIterator_HeaderFile
#include <BOP_BlockIterator.hxx>
#endif
#ifndef _BOP_BlockBuilder_HeaderFile
#include <BOP_BlockBuilder.hxx>
#endif
#ifndef _BOP_SolidAreaBuilder_HeaderFile
#include <BOP_SolidAreaBuilder.hxx>
#endif
#ifndef _Standard_Boolean_HeaderFile
#include <Standard_Boolean.hxx>
#endif
#ifndef _Standard_Integer_HeaderFile
#include <Standard_Integer.hxx>
#endif
class BOP_ShellFaceSet;
class TopoDS_Shell;
class TopoDS_Face;
class BOP_ShapeSet;



//!   Construct Solids from a Shell Faces  Set (SFS) <br>
class BOP_SolidBuilder  {
public:

  void* operator new(size_t,void* anAddress) 
  {
    return anAddress;
  }
  void* operator new(size_t size) 
  {
    return Standard::Allocate(size); 
  }
  void  operator delete(void *anAddress) 
  {
    if (anAddress) Standard::Free((Standard_Address&)anAddress); 
  }

  
//! Empty constructor; <br>
  Standard_EXPORT   BOP_SolidBuilder();
  
//! The constructor that just calls the method <br>
//! InitSolidBuilder() below <br>
  Standard_EXPORT   BOP_SolidBuilder(BOP_ShellFaceSet& theSFS,const Standard_Boolean theForceClassFlag = Standard_False);
  
//! Launches the algorithm consisting of four steps <br>
//! 1.  Split the SFS on shells ( BOP_SFSCorrector object) <br>
//! 2.  Make Loops from shells  ( this->MakeLoops() ) <br>
//! 3.  Make Areas from Loops   ( BOP_SolidAreaBuilder object) <br>
//! 4.  Make Solids from Areas  ( see methods below ) <br>
  Standard_EXPORT     void InitSolidBuilder(BOP_ShellFaceSet& theSFS,const Standard_Boolean theForceClassFlag) ;
  
  Standard_EXPORT     Standard_Integer InitSolid() ;
  
  Standard_EXPORT     Standard_Boolean MoreSolid() const;
  
  Standard_EXPORT     void NextSolid() ;
  
  Standard_EXPORT     Standard_Integer InitShell() ;
  
  Standard_EXPORT     Standard_Boolean MoreShell() const;
  
  Standard_EXPORT     void NextShell() ;
  
  Standard_EXPORT     Standard_Boolean IsOldShell() const;
  
  Standard_EXPORT     TopoDS_Shell OldShell() const;
  
  Standard_EXPORT     Standard_Integer InitFace() ;
  
  Standard_EXPORT     Standard_Boolean MoreFace() const;
  
  Standard_EXPORT     void NextFace() ;
  
//! Returns current new face of current new shell. <br>
  Standard_EXPORT    const TopoDS_Face& Face() const;





protected:





private:

  
  Standard_EXPORT     void MakeLoops(BOP_ShapeSet& theSFS) ;


BOP_LoopSet myLoopSet;
BOP_BlockIterator myBlockIterator;
BOP_BlockBuilder myBlockBuilder;
BOP_SolidAreaBuilder mySolidAreaBuilder;


};





// other Inline functions and methods (like "C++: function call" methods)


#endif
